package SquareClient;

import netscape.security.*;
import java.awt.*;
import java.awt.Component.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import comm.*;

public class square extends Applet
{
  /* --------> */ static int debug = 0;
  static Socket sock;
  static String nickname;
  static String server;
  static int port;
  static int flag = 0;
  static boolean connect = false;
  static boolean login_frame_visible = false;
  static boolean first_connect = true;
  static int pos_x = 150, pos_y = 150;
  static boolean sex; // true = maschio
  static int face;
  static UsersList utenti;
  static boolean cambia_server = false;

  static Button happier;
  static Button angrier;

  static Button up;
  static Button down;
  static Button left;
  static Button right;  

  static TextField in;   // input
  static TextArea  out;  // output;

  static sq_canvas sq;      // la piazza
  static login_frame lf;

  static Image boy0,boy1,boy2;
  static Image girl0,girl1,girl2;

    static PrivilegeManager privMgr = null;

  static ObjectOutputStream oos; // stream di out
  static ObjectInputStream  ois; // stream di in

  update ud;

public void init()
    {
      if (debug == 1) System.err.println("INIT");

      square.utenti = new UsersList();

       privMgr = PrivilegeManager.getPrivilegeManager();

      // prende i parametri

      server = getParameter("server");
      port   = Integer.parseInt(getParameter("port"));

      // carica le immagini

     try
     	{
	privMgr.enablePrivilege("UniversalConnect");
	boy0 = getImage(getCodeBase(), "images/boy0.gif");
	boy1 = getImage(getCodeBase(), "images/boy1.gif");
	boy2 = getImage(getCodeBase(), "images/boy2.gif");
     	girl0 = getImage(getCodeBase(), "images/girl0.gif");
	girl1 = getImage(getCodeBase(), "images/girl1.gif");
	girl2 = getImage(getCodeBase(), "images/girl2.gif");
	}
     catch(Exception ex)
	{
       	if (debug == 1) System.err.println("Errore: " + ex);
	error err = new error("Permission to enable network privilege denied by user.");
       	//square.stop();
    	}
		
      resize(650,400);

      // setta il layout

      GridBagLayout gridbag = new GridBagLayout();
      GridBagConstraints c = new GridBagConstraints();
      setLayout(gridbag);
      c.fill = GridBagConstraints.BOTH;

      // crea i winget

      sq = new sq_canvas();
      sq.setBackground(Color.gray);
      sq.resize(300,300);
      c.gridwidth  = 4;
      c.gridheight = 10;
      gridbag.setConstraints(sq, c);
      add(sq);

      c.weightx = 1.0 ;
      c.gridwidth  = 1;
      c.gridheight = 1;     

      up = new Button("UP");
      gridbag.setConstraints(up, c);
      add(up);

      c.gridwidth  = GridBagConstraints.REMAINDER;

      down = new Button("DOWN");
      gridbag.setConstraints(down, c);
      add(down);

      c.gridwidth  = 1;

      left = new Button("LEFT");
      gridbag.setConstraints(left, c);
      add(left);

      c.gridwidth  = GridBagConstraints.REMAINDER;

      right = new Button("RIGHT");
      gridbag.setConstraints(right, c);
      add(right);

      c.gridwidth  = 1;

      angrier = new Button("ANGRIER");
      gridbag.setConstraints(angrier, c);
      add(angrier);

      c.gridwidth  = GridBagConstraints.REMAINDER;

      happier = new Button("HAPPIER");
      gridbag.setConstraints(happier, c);
      add(happier);


      out = new TextArea(); // TextArea("",righe, colonne, TextArea.SCROLLBARS_VERTICAL_ONLY);
      c.gridwidth  = GridBagConstraints.REMAINDER;
      c.gridheight = 7;
      gridbag.setConstraints(out, c);
      out.setEditable(false);
      add(out);

      in = new TextField();
      c.gridwidth  = GridBagConstraints.REMAINDER;
      c.gridheight = GridBagConstraints.REMAINDER;
      gridbag.setConstraints(in, c);
      add(in);

      comandi(false);
      }

public void start()
	{
	if (debug == 1) System.err.println("START");
	if (debug == 1) System.err.println("connect : " + connect);
	if (debug == 1) System.err.println("first   : " + first_connect);
	
	// se  il primo collegamento ottieni il nickname che identifichera' il client
	if (first_connect == true && connect == false)
      		{
	      	if(login_frame_visible == false)
        		 {
		         comandi(false);
		         lf = new login_frame(server,port);
	        	 if (debug == 1) System.err.println("LOG IN ");
			 }
		}
	else
      		{
		// riconnessione col nickname, il sesso e la posizione che l'utente aveva quando si  disconnesso	
		connect();
		}	
      }
   
public void connect()
    {
	 square.privMgr.enablePrivilege("UniversalConnect");

      try
	{
	  // ricrea socket, input e output streams
	  square.sock = new Socket(server, port);
	  square.oos  = new ObjectOutputStream( sock.getOutputStream()); // APRE LO STREAM DI OUTPUT
	  square.oos.flush();

	  // sono l'utente di prima, mi accetti ancora?
	  String sesso;
	  if (square.sex)
	    sesso = "UOMO";
	  else
	    sesso = "DONNA";

	  // annuncia che sono un client
	  comando cmd = new comando("CLIENTE"); 
	  square.oos.writeObject( (comando) cmd);				
	  square.oos.flush();	  
	  
	  String arg2[] = { square.nickname,  "" + square.face , "" + square.pos_x, "" + square.pos_y, sesso };
	  cmd = new comando("NUOVO", arg2 ); 
		
	  square.oos.writeObject( (comando) cmd);				
	  square.oos.flush();

	  square.ois  = new ObjectInputStream( sock.getInputStream());
	  comando fromServer = (comando) square.ois.readObject(); // APRE LO STREAM DI INPUT

	  if ( ! fromServer.cmd.equals("OK"))
	    {
	      sock.close();
	      error err = new error(fromServer.cmd);
	    }
	  else
	    {
	      // tutto bene siamo ON LINE :-)
                  
	      square.connect  = true;
	      square.comandi(true);

	      try
		{
		   square.privMgr.enablePrivilege("UniversalThreadAccess");
		  ud = new update(square.nickname);    // crea il thread
		  ud.start();
		}
	      catch(Exception ex)
		{
		  //square.stop();
		}
	    }
	}
      catch(Exception ex)
	{
	}
    }
	
public void stop()
    {
      if (debug == 1) System.err.println("STOP");
      
      // avverti il server che voglio uscire
      if (connect == true)
	{
	  comandi(false);
	  connect = false;
	  try
            {
	       privMgr.enablePrivilege("UniversalConnect");

	      square.oos.writeObject( new comando("ESCI") );
	      square.oos.flush();

	      // il thread di update deve essere terminato
	      ud.stop();

	      sock.close();
            } 
	  catch(Exception ex)
            {
	      // non fare nulla   
            }
	}

      // chiudi tutto
      if (square.login_frame_visible)
      	{
	  square.lf.dispose();
	  square.login_frame_visible = false;
	}
    }
      
  static public void comandi(boolean abilito)
    {
      happier.enable(abilito);
      angrier.enable(abilito);

      up.enable(abilito);
      down.enable(abilito);
      left.enable(abilito);
      right.enable(abilito);
      in.enable(abilito);
    }

static public void aggiorna_messaggi()
    {
      user u = (user) square.utenti.elementAt(square.utenti.indice( square.nickname ));
      
      while( u.messaggi() )
	square.out.append( u.dammi_messaggio() + "\n");
    }

public boolean action(Event e, Object o)
	{
	  boolean flag = false;

	  try
	    {
	      comandi(false);
	       privMgr.enablePrivilege("UniversalConnect");
	      comando cmd;
		
	      if (e.target instanceof Button)
		{
		  if ("UP".equals( ((Button)e.target) .getLabel() ))
		    {
		      square.pos_y = square.pos_y-5;
		      String arg[] = { "" + square.pos_x, "" + square.pos_y };
		      cmd = new comando("MUOVI", arg );

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }

		  if ("DOWN".equals( ((Button)e.target) .getLabel() ))
		    {
		      square.pos_y = square.pos_y+5;
		      String arg[] =  { "" + square.pos_x, "" + square.pos_y };
		      cmd = new comando("MUOVI",arg );

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }

		  if ("LEFT".equals( ((Button)e.target) .getLabel() ))
		    {
		      square.pos_x = square.pos_x-5;
		      String arg[] =  { "" + square.pos_x, "" + square.pos_y };
		      cmd = new comando("MUOVI", arg );

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }

		  if ("RIGHT".equals( ((Button)e.target) .getLabel() ))
		    {
		      square.pos_x = square.pos_x+5;
		      String arg[] = { "" + square.pos_x, "" + square.pos_y };
		      cmd = new comando("MUOVI", arg );

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }

		  if("HAPPIER".equals( ((Button)e.target) .getLabel() ))
		    {
		      String arg[] = { "FELICE" };
		      cmd = new comando ("ESPRESSIONE", arg);

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }

		  if("ANGRIER".equals( ((Button)e.target) .getLabel() ))
		    {
		      String arg[] =  { "ARRABBIATO" };
		      cmd = new comando("ESPRESSIONE", arg);

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		    }
		}

	      if (e.target instanceof TextField)
		{
		  if (connect == true)   // siamo on-line  un messaggio
		    {
		      String arg[] = { (String) o};
		      cmd = new comando("MESSAGGIO", arg ); 

		      square.oos.writeObject( (comando) cmd);
		      square.oos.flush();
		      flag = true;
		      in.setText("");
		    }
		}
	    }
	  catch(Exception ex)
	    {
	      if (ex.equals("netscape.security.ForbiddenTargetException"))
		{
		  error err = new error("Permission to enable network privilege denied by user.");
		}
	      else
		{
		  error err = new error("Command not accepted : the Server may be down or very busy");
		}
	      comandi(false);
	    }      

	  comandi(true);
	  return flag; // true se c'e' stata una operazione
	}
}

class sq_canvas extends Canvas
{
public void paint(Graphics g)
    {
      if (square.utenti != null)
	{
	  square.utenti.prendi_controllo();

	  for (int cont = 0; cont < square.utenti.size(); cont++)
            {
	      user u = (user) square.utenti.elementAt(cont);

	      if (u.dammi_nome().equals(square.nickname))
		{
		  g.setColor(Color.blue);
		  g.drawOval(u.dammi_x()-30, u.dammi_y()-30, 60, 60);
		  g.setColor(Color.red);
		}
	      else
		g.setColor(Color.black);

	      g.drawString(u.dammi_nome(),u.dammi_x()-5, u.dammi_y() + 25);

	      if (u.dammi_sesso()) // UOMO
		{
		  if (u.dammi_espressione() == 0)
		    g.drawImage(square.boy0,u.dammi_x()-10, u.dammi_y()-10,this); // normale
		  if (u.dammi_espressione() == 1)
		    g.drawImage(square.boy1,u.dammi_x()-10, u.dammi_y()-10,this); // felice
		  if (u.dammi_espressione() == 2)
		    g.drawImage(square.boy2,u.dammi_x()-10, u.dammi_y()-10,this); // arrabbiato
		}
	      else    // DONNA
		{
		  if (u.dammi_espressione() == 0)
		    g.drawImage(square.girl0,u.dammi_x()-10, u.dammi_y()-10,this); // normale
		  if (u.dammi_espressione() == 1)
		    g.drawImage(square.girl1,u.dammi_x()-10, u.dammi_y()-10,this); // felice
		  if (u.dammi_espressione() == 2)
		    g.drawImage(square.girl2,u.dammi_x()-10, u.dammi_y()-10,this); // arrabbiato
		}
            }
	  square.utenti.cedi_controllo();
	}
    }
}


// ****************************************** LOGIN FRAME

class login_frame extends Frame
{
  boolean sex_flag = false, nickname_flag = false;
  String server;
  int port;
  Label descrizione;
  Label nick;
  Label sex;
  TextField in;
  Checkbox  male;
  Checkbox  famale;
  Button login;

public login_frame(String server, int port)
    {
      this.server = server;
      this.port  = port;

      // la finestra di login  visualizzata
      square.login_frame_visible = true;      

      //Object definitions
      descrizione = new Label("INSERT YOUR NICKNAME AND YOUR SEX");
      nick        = new Label("Nickname");
      sex         = new Label("Sex");
      in          = new TextField();
      male        = new Checkbox("Male");
      famale      = new Checkbox("Famale");

      resize(370,130);
      move(275,235);

      // setta il layout

      GridBagLayout gridbag = new GridBagLayout();
      GridBagConstraints c = new GridBagConstraints();
      setLayout(gridbag);

      c.fill = GridBagConstraints.BOTH;

      // posizona i winget

      c.gridwidth  = GridBagConstraints.REMAINDER;
      c.gridheight = 1;
      gridbag.setConstraints(descrizione, c);
      descrizione.setAlignment(Label.CENTER);
      descrizione.setFont(new Font("TimesRoman",Font.BOLD,16));
      add(descrizione);

      c.gridwidth  = 1;
      gridbag.setConstraints(nick, c);
      add(nick);

      c.gridwidth  = GridBagConstraints.REMAINDER;
      gridbag.setConstraints(in, c);
      add(in);

      c.gridheight = GridBagConstraints.REMAINDER;
      
      c.gridwidth  = 1;
      gridbag.setConstraints(sex, c);
      add(sex);

      c.gridwidth  = 1;
      gridbag.setConstraints(male, c);
      add(male);

      c.gridwidth  = GridBagConstraints.REMAINDER;
      gridbag.setConstraints(famale, c);
      add(famale);

      descrizione.enable(true);
      nick.enable(true);
      sex.enable(true);
      in.enable(true);
      male.enable(true);
      famale.enable(true);
      enable(true);
      show();
    }

public boolean action(Event e, Object o)
    {
      boolean f = false;

      if (e.target instanceof Checkbox)
	{
	  if ("Male".equals( ((Checkbox)e.target) .getLabel() ))
            {
	      sex_flag      = true;
	      square.sex    = true;
	      famale.setState(false);
	      f = true;
            }

	  if ("Famale".equals( ((Checkbox)e.target) .getLabel() ))
            {
	      sex_flag      = true;
	      square.sex    = false;
	      male.setState(false);
	      f = true;
            }
	}

      if (e.target instanceof TextField)
	{
	  square.nickname = in.getText();
	  
	  if (square.nickname != "" && square.nickname != null)
            nickname_flag = true;
	  f = true;
	}

      if (sex_flag && nickname_flag)
	{
	  try
            {
	      if (square.nickname != null)
		{
		    do
			{
			    //login			
			    square.privMgr.enablePrivilege("UniversalConnect");

			    Socket sock = new Socket(server, port);
		  
			    square.oos = new ObjectOutputStream( sock.getOutputStream() ); // APRE LO STREAM DI OUTPUT
			    square.oos.flush();
		
			    // ------------------------

			    // annuncia che sono un client
			    comando cmd = new comando("CLIENTE"); 
			    square.oos.writeObject( (comando) cmd);				
			    square.oos.flush();	  

			    String sesso;
			    if (square.sex)
				sesso = "UOMO";
			    else
				sesso = "DONNA";

			    String arg2[] = { square.nickname,  "" + square.face , "" + square.pos_x, "" + square.pos_y, sesso };
			    cmd = new comando("NUOVO", arg2 ); 
		
			    square.oos.writeObject( (comando) cmd);				
			    square.oos.flush();

			    square.ois = new ObjectInputStream( sock.getInputStream() );
			    comando fromServer = (comando) square.ois.readObject();

			    if ( fromServer.cmd.equals("CAMBIA SERVER"))
				{
				    square.cambia_server = true;
				    System.err.println("Ho ricevuto dal server l'ordine di cambiare server");
				    System.err.println("porta: " + fromServer.port);
				    System.err.println("ip   : " + fromServer.ip.toString());
				    sock.close();
				    this.port = fromServer.port;
				    this.server = fromServer.ip.getHostAddress();
				    this.dispose();
				}
			    else
				{
				    if ( ! fromServer.cmd.equals("OK"))
					{
					    sock.close();
					    error err = new error(fromServer.cmd);
					}
				    else
					{
					    // tutto bene siamo ON LINE :-)
                  
					    if (square.debug == 1) System.out.println("SIAMO ON-LINE");
					    square.cambia_server = false;
					    square.connect = true;
					    square.first_connect = false;
					    square.comandi(true);

					    try
						{
						    square.privMgr.enablePrivilege("UniversalThreadAccess");
						    update ud = new update(square.nickname);    // crea il thread
						    ud.start();
						}
					    catch(Exception ex)
						{
						    //square.stop();
						}

					    this.dispose();
					    square.login_frame_visible = false;
					}
				}
			} while (square.cambia_server);
		}
	    }
	  catch(Exception ex)
	      {
		  error err = new error("The Server may be down or busy, try later: " + ex);
	      }
	  f = true;
	}
      return f;
    }
}
