package comm;

import java.util.Vector;
import java.io.Serializable;

public class user implements Serializable
{
private String  nome;        // nome dell'utente
private int     x;           // posizione: coordinata x
private int     y;           // posizione: coordinata y
private Vector  msg;         // messaggi inviati all'utente
private boolean sesso;       // true maschio, false femmina
private int     espressione; // 0 normale | 1 felice | 2 arrabbiato

public user(String nome, boolean sesso)
    {
      this.nome        = nome;
      this.x           = 0;
      this.y           = 0;
      this.sesso       = sesso;
      this.espressione = 0;
      this.msg         = new Vector();
    }

public String dammi_nome() // ritorna il nome dell'utente
    {
      return this.nome;
    }

public int dammi_espressione() // ritorna l'epressione dell'utente
    {
      return this.espressione;
    }

public void setta_espressione(int e)
    {
      if (e >= 0 && e <= 2)
	{
	  this.espressione = e;
	}
    }

public boolean dammi_sesso() // ritorna il sesso dell'utente (true==maschio)
    {
      return this.sesso;
    }

public boolean equals(user u)
    {
      if (u.nome == this.nome)
	return true;
      else
	return false;
    }

public void rimuovi_messaggi()
    {
      this.msg = new Vector();
    }

public String dammi_messaggio() // ritorna il primo messaggio
    {
      String temp;
      
      if (msg.size() > 0)
	{
	  temp = (String) msg.firstElement();
	  msg.removeElementAt(0);
	  return temp;
	}
      else
	return (String) "";
    }

  //public int nm() // ritorna il numero di messaggi
  //{
  //  return msg.size();
  //}

  public void add_m(String mittente, String messaggio)
    {
      msg.addElement(mittente + "> "+ messaggio);
    }


  public boolean messaggi() // ritorna vero se ci sono messaggi
    {
      if (msg.size() > 0)
	return true;
      else
	return false;
    }

  public int dammi_x()
    {
      return x;
    }

  public int dammi_y()
    {
      return y;
    }

  public void setta_x(int x)
    {
      this.x = x;
    }

  public void setta_y(int y)
    {
      this.y = y;
    }
}
