// al fine di gestire accuratamente la concorrenza si  deciso di gestire lo stato con un monitor
// poich i metodi della classe Vector sono definiti final non  stato possibile gestire la concorrenza in maniera trasparente ed  stato necessario introdurre i due metodi prendi_controllo() e cedi_controllo() che devono essere invocati prima e dopo una azione sull'oggetto

package comm;

import java.util.Vector;
import java.io.Serializable;

public class UsersList extends Vector implements Serializable
{
private boolean occupato = false;

public synchronized void prendi_controllo()
    {
      while(occupato == true)
	try
	  {
	    wait();
	  }
      catch(InterruptedException e)
	{
	  // non fare niente
	}

      occupato = true;
    }

public synchronized void cedi_controllo()
    {
      occupato = false;
      notifyAll();
    }

public UsersList()
    {
      super();
    }

  // ritorna l'indice dell'utente "nome"
public synchronized int indice(String nome)
    {
      int cont,flag = 0;

      for (cont = 0; cont < this.size(); cont ++)
	{
	  if (((user) this.elementAt(cont)).dammi_nome().equals(nome))
	    {
	      flag = 1;
	      break;
	    }
	}

      if (flag == 1) return cont;
      else return -1;
    }
}
